package main

import (
	"fmt"
)

var myMaze = make([][]int, 0)
var visited = make([][]int, 0)

func printSolution() {
	for _, v := range visited {
		for _, c := range v {
			fmt.Print(c, " ")
		}
		fmt.Println()
	}
}

func solveMaze(x, y, dx, dy int) bool {
	xx := len(myMaze)
	yy := len(myMaze[0])

	if x == dx && y == dy && myMaze[x][y] != 0 {
		visited[x][y] = 1
		return true
	}

	if x >= 0 && y >= 0 && x < xx && y < yy && visited[x][y] == 0 && myMaze[x][y] == 1 {
		visited[x][y] = 1
		if solveMaze(x+1, y, dx, dy) {
			return true
		}
		if solveMaze(x, y+1, dx, dy) {
			return true
		}
		if solveMaze(x-1, y, dx, dy) {
			return true
		}
		if solveMaze(x, y-1, dx, dy) {
			return true
		}
	}
	return false
}

func main() {
	myMaze = [][]int{
		{1, 1, 1, 1},
		{1, 1, 0, 1},
		{0, 0, 0, 0},
		{1, 1, 0, 0},
		{1, 0, 0, 0}}

	visited = [][]int{
		{0, 0, 0, 0},
		{0, 0, 0, 0},
		{0, 0, 0, 0},
		{0, 0, 0, 0},
		{0, 0, 0, 0}}

	if solveMaze(0, 1, 0, 2) {
		fmt.Println("Maze is solvable!")
		printSolution()
	} else {
		fmt.Println("Maze not solvable.")
	}
}
