package main

import (
	"fmt"
	"math/rand"
	"os"
	"strconv"
	"time"
)

func newMaze(rows, cols int) [][]int {
	var mySlice = make([][]int, 0)

	for i := 0; i < rows; i++ {
		temp := make([]int, 0)
		for k := 0; k < cols; k++ {
			n := rand.Intn(3)
			if n == 0 {
				temp = append(temp, 0)
			} else {
				temp = append(temp, 1)
			}
		}
		mySlice = append(mySlice, temp)
	}

	return mySlice
}

func printSlice(x [][]int) {
	for _, v := range x {
		for _, c := range v {
			fmt.Print(c, " ")
		}
		fmt.Println()
	}
}

func main() {
	arguments := os.Args
	if len(arguments) == 1 {
		fmt.Printf("usage: createMaze rows columns\n")
		return
	}

	r, err := strconv.Atoi(arguments[1])
	if err != nil {
		fmt.Println(err)
		return
	}

	c, err := strconv.Atoi(arguments[2])
	if err != nil {
		fmt.Println(err)
		return
	}

	rand.Seed(time.Now().UnixNano())
	mySlice := newMaze(r, c)
	printSlice(mySlice)
}
